#include <QtTest>
#include <QDebug>
#include "appchooser.h"

class TestAppChooser : public QObject
{
    Q_OBJECT

private Q_SLOTS:
    void test_getDefaultApp();
    void test_getAvailableAppList();

private:
    AppChooser m_appChooser;
};

void TestAppChooser::test_getDefaultApp()
{
    std::string defaultApp = m_appChooser.getDefaultAppForUrl("https://www.baidu.com");
    QVERIFY(!defaultApp.empty());

    defaultApp = m_appChooser.getDefaultAppForUrl("file:///tmp/test.txt");
    QVERIFY(!defaultApp.empty());

    defaultApp = m_appChooser.getDefaultAppForUrl("file:///tmp/picture.png");
    QVERIFY(!defaultApp.empty());
}

void TestAppChooser::test_getAvailableAppList()
{
    std::vector<std::string> appList =
        m_appChooser.getAvailableAppListForFile("/tmp/test.txt");
    QVERIFY(!appList.empty());

    appList = m_appChooser.getAvailableAppListForFile("/tmp/picture.png");
    QVERIFY(!appList.empty());
}


QTEST_MAIN(TestAppChooser)

#include "tst_appchooser.moc"
