#include <QtTest>
#include <QCoreApplication>
#include <QGSettings/qgsettings.h>
#include "configmanager.h"

// add necessary includes here

class TestConfigManager : public QObject
{
    Q_OBJECT

public:
    TestConfigManager();
    ~TestConfigManager();

private Q_SLOTS:
    void initTestCase();
    void cleanupTestCase();
    void test_case1();
};

TestConfigManager::TestConfigManager()
{

}

TestConfigManager::~TestConfigManager()
{

}

void TestConfigManager::initTestCase()
{

}

void TestConfigManager::cleanupTestCase()
{

}

void TestConfigManager::test_case1()
{
    ConfigManager cm;
    QGSettings gsettings("com.kylin.ProcessManager");

    bool limitEnabled = gsettings.get("resourceLimitEnabled").toBool();
    QVERIFY(cm.background2CachedStateInterval(sched_policy::DeviceMode::PC) > 0);
    QVERIFY(cm.background2CachedStateInterval(sched_policy::DeviceMode::Tablet) > 0);
    QVERIFY(cm.background2CachedStateInterval(sched_policy::DeviceMode::SoftFreeze) > 0);
    QVERIFY(cm.reousrceLimitEnabled() == gsettings.get("resourceLimitEnabled").toBool());

    gsettings.set("resourceLimitEnabled", !limitEnabled);
    QVERIFY(cm.reousrceLimitEnabled() == gsettings.get("resourceLimitEnabled").toBool());
}

QTEST_MAIN(TestConfigManager)

#include "tst_configmanager.moc"
