#include <QtTest>
#include <QCoreApplication>
#include <QGSettings/qgsettings.h>
#include "exceptiongroupprocesswatcher.h"

// add necessary includes here

class TestExceptionGroupProcessWatcher : public QObject
{
    Q_OBJECT

public:
    TestExceptionGroupProcessWatcher();
    ~TestExceptionGroupProcessWatcher();

private Q_SLOTS:
    void initTestCase();
    void cleanupTestCase();
    void test_case1();
};

TestExceptionGroupProcessWatcher::TestExceptionGroupProcessWatcher()
{

}

TestExceptionGroupProcessWatcher::~TestExceptionGroupProcessWatcher()
{

}

void TestExceptionGroupProcessWatcher::initTestCase()
{

}

void TestExceptionGroupProcessWatcher::cleanupTestCase()
{

}

void TestExceptionGroupProcessWatcher::test_case1()
{
    QEventLoop eventLoop;
    auto pim = std::make_shared<ProcessInfoManager>(std::make_shared<ConfigManager>());
    ExceptionGroupProcessWatcher watcher(pim);
    connect(&watcher, &ExceptionGroupProcessWatcher::exceptionSessionAppCaught, this, [&watcher](const std::string &desktopFile, int pid) {
        qDebug() << "exceptionSessionAppCaught: " << QString::fromStdString(desktopFile) << pid;
        watcher.stopWatcher();
    });

    connect(&watcher, &ExceptionGroupProcessWatcher::exceptionSessionAppCaught, &eventLoop, &QEventLoop::quit);

    watcher.addPath("/sys/fs/cgroup/systemd/user.slice/user-1000.slice/session-1.scope", sched_policy::GroupType::SessionScopeGroup);
    watcher.startWatcher();
    eventLoop.exec();
}

QTEST_MAIN(TestExceptionGroupProcessWatcher)

#include "tst_exceptiongroupprocesswatcher.moc"
