#include <QtTest>
#include <QCoreApplication>
#include <QEventLoop>
#include "timewheel.h"

class TestTimeWheel : public QObject
{
    Q_OBJECT

public:
    TestTimeWheel();
    ~TestTimeWheel();

private Q_SLOTS:
    void initTestCase();
    void cleanupTestCase();
    void test_case1();
};

TestTimeWheel::TestTimeWheel()
{

}

TestTimeWheel::~TestTimeWheel()
{

}

void TestTimeWheel::initTestCase()
{

}

void TestTimeWheel::cleanupTestCase()
{

}

void TestTimeWheel::test_case1()
{
    QEventLoop eventLoop;
    timewheel::TimeWheel tw;
    int counter = 0;
    tw.addTimer(1, [&counter]() {
        ++ counter;
    });

    auto timerId = tw.addTimer(3, [&counter]() {
        ++ counter;
    });

    tw.addTimer(2, [&tw, &counter, &timerId]() {
        ++ counter;
        tw.deleteTimer(timerId);
    });

    tw.addTimer(4, [&eventLoop, &counter, &tw]() {
        QVERIFY(counter == 2);
        eventLoop.quit();
    });
    eventLoop.exec();
}

QTEST_MAIN(TestTimeWheel)

#include "tst_timewheel.moc"
