#include "profileaction.h"
#include <iostream>

ProfileAction::~ProfileAction() = default;

SetAttributeAction::SetAttributeAction(
    std::unique_ptr<ProfileAttribute> attribute, const std::string &value,
    const std::shared_ptr<ResourceManagerInterface> &resourceInterface)
    : m_attribute(std::move(attribute))
    , m_value(value)
    , m_resourceInterface(resourceInterface)
{
}

std::string SetAttributeAction::name() const
{
    return "SetAttributeAction";
}

std::string SetAttributeAction::cgroupControllerName() const
{
    return m_attribute->controllerName();
}

void SetAttributeAction::executeForCgroup(const std::string &path)
{
    m_resourceInterface->setProcessGroupResourceLimit(
        path, m_attribute->controllerName(), m_attribute->fileName(), m_value);
}
