#ifndef PROFILEACTION_H
#define PROFILEACTION_H

#include <string>
#include <memory>
#include <vector>
#include "profileattribute.h"
#include "resourcemanagerinterface.h"

class ProfileAction
{
public:
    virtual ~ProfileAction() = 0;
    virtual std::string name() const = 0;
    virtual std::string cgroupControllerName() const = 0;
    virtual void executeForCgroup(const std::string &path) = 0;
};

class SetAttributeAction : public ProfileAction
{
public:
    SetAttributeAction(
        std::unique_ptr<ProfileAttribute> attribute, const std::string &value,
        const std::shared_ptr<ResourceManagerInterface> &resourceInterface);
    ~SetAttributeAction() = default;
    std::string name() const override;
    std::string cgroupControllerName() const override;
    void executeForCgroup(const std::string &path) override;

private:
    std::unique_ptr<ProfileAttribute> m_attribute;
    std::string m_value;
    std::shared_ptr<ResourceManagerInterface> m_resourceInterface;
};

#endif // PROFILEACTION_H
