#ifndef PROFILEATTRIBUTE_H
#define PROFILEATTRIBUTE_H

#include <string>

class ProfileAttribute
{
public:
    virtual ~ProfileAttribute() = 0;
    virtual std::string name() const = 0;
    virtual std::string controllerName() const = 0;
    virtual std::string fileName() const = 0;
};

class CgroupProfileAttribute : public ProfileAttribute
{
public:
    CgroupProfileAttribute(const std::string &name, 
                           const std::string &controllerName, 
                           const std::string &fileName);

    virtual ~CgroupProfileAttribute() = default;
    virtual std::string name() const override;
    virtual std::string controllerName() const override;
    virtual std::string fileName() const override;

private:
    std::string m_name;
    std::string m_controllerName;
    std::string m_fileName;
};
#endif // PROFILEATTRIBUTE_H
