#include "resourcecontroller.h"
#include <iostream>
#include <algorithm>

ResourceController::ResourceController(const std::string &name)
    : m_name(name)
{

}

std::string ResourceController::name() const
{
    return m_name;
}

std::vector<std::string> ResourceController::cgroupControllerNames() const
{
    std::vector<std::string> controllerNames;
    for (const auto &action : m_actions) {
        auto it = std::find(controllerNames.begin(), controllerNames.end(), action->cgroupControllerName());
        if (it == controllerNames.end()) {
            controllerNames.emplace_back(action->cgroupControllerName());
        }
    }
    return controllerNames;
}

void ResourceController::addAction(std::unique_ptr<ProfileAction> action) 
{
    m_actions.emplace_back(std::move(action));
}

void ResourceController::executeForCgroup(const std::string &path)
{
    for (const auto &action : m_actions) {
        action->executeForCgroup(path);
    }
}
