#ifndef RESOURCECONTROLLER_H
#define RESOURCECONTROLLER_H

#include <string>
#include <vector>
#include "profileaction.h"

class ResourceController
{
public:
    ResourceController(const std::string &name);
    ResourceController(const ResourceController &) = delete;
    std::string name() const;
    std::vector<std::string> cgroupControllerNames() const;
    void addAction(std::unique_ptr<ProfileAction> action);
    void executeForCgroup(const std::string &path);

private:
    std::string m_name;
    std::vector<std::unique_ptr<ProfileAction>> m_actions;
};

#endif // RESOURCECONTROLLER_H
