#ifndef SCHEDPOLICY_H
#define SCHEDPOLICY_H

#include <string>
#include <map>

namespace sched_policy {

enum class AppState {
    Focus,
    Foreground,
    Background,
    Cached,
};

enum class AppType {
    Unknown,
    Normal,
    Top,
    Session,
};

enum class GroupType {
    Unknown,
    SessionScopeGroup,
    SessionGroup,
    TopGroup,
    FocusGroup,
    ForegroundGroup,
    BackgroundGroup,
    CachedGroup,
    DefaultGroup,
};

enum class DeviceMode {
    Unknown,
    PC,
    Tablet,
    SoftFreeze,
};

enum class PowerMode {
    Unknown,
    Balance,
    Save,
    Performance,
};

enum class PowerType {
    Battery,
    Ac
};

DeviceMode deviceModeFromString(const std::string &mode);
PowerMode powerModeFromString(const std::string &mode);
GroupType groupTypeFromString(const std::string &type);

std::string deviceModeToString(DeviceMode mode);

std::string generatePolicyId(const std::string &deviceMode, const std::string &powerMode);
std::string generatePolicyId(DeviceMode deviceMode, PowerMode powerMode);

}

#endif // SCHEDPOLICY_H
