#ifndef SINGLETON_H
#define SINGLETON_H

template <typename T>
class Singleton
{
public:
    Singleton() = delete;
    Singleton(const Singleton &) = delete;
    Singleton(Singleton &&) = delete;

    static T &instance()
    {
        static T instance;
        return instance;
    }
};

#endif // SINGLETON_H
