#ifndef SYSTEMDDBUSINTERFACE_H
#define SYSTEMDDBUSINTERFACE_H

#include <QDBusVariant>
#include <QDBusConnection>
#include <string>

class SystemdDbusInterface
{
public:
    SystemdDbusInterface();
    std::string currentUserSliceName() const;
    std::string currentUserServiceName() const;
    std::string currentSessionScopeName() const;

    void createTransientProcessGroup(const std::string &name,
                                     std::vector<int> pids,
                                     const std::string &parentSlice);

    void setSystemdUnitPropertyEnabled(
        const QString &unitName, const QString &propertyName, bool enabled);

    std::vector<int> getUnitProcessIds(const std::string &unitName) const;

private:
    using NamedVariant = QPair<QString, QDBusVariant>;
    using NamedVariantList = QList<NamedVariant>;
    void registerDbusTypes();

    std::string getCurrentLoginProperty(
        const std::string &property, const std::string &interface,
        const std::string &path) const;

    void asyncCallSystemdDbus(
        const QString &method, const QList<QVariant> &arguments,
        QDBusConnection dbusConnection);
};

#endif // SYSTEMDDBUSINTERFACE_H
