#ifndef APPCHOOSER_H
#define APPCHOOSER_H

#include <QUrl>
#include <string>
#include <vector>

class AppChooser
{
public:
    AppChooser() = default;

    std::string getDefaultAppForUrl(const std::string &url);
    std::vector<std::string> getAvailableAppListForFile(const std::string &fileName);

private:
    std::string getDefaultAppForLocalFile(const QUrl &url);
    std::string getDefaultAppForUrlScheme(const std::string &urlScheme);
    std::string getMimeContentTypeFromFile(const std::string &fileName);
};

#endif // APPCHOOSER_H
