#ifndef APPLAUNCHMANAGER_H
#define APPLAUNCHMANAGER_H

#include <QObject>
#include <QDBusContext>
#include <memory>
#include "applauncher.h"
#include "appchooser.h"
#include "processinfomanager.h"

class AppLaunchManager : public QObject, public QDBusContext
{
    Q_OBJECT
public:
    AppLaunchManager(
        ProcessInfoManager &processInfoManager, QObject *parent = nullptr);

    void LaunchApp(const QString &desktopFile);
    void LaunchAppWithArguments(const QString &desktopFile, const QStringList &args);
    void LaunchDefaultAppWithUrl(const QString &url);
    void RunCommand(const QString &command);
    QStringList GetAvailableAppListForFile(const QString &fileName);
    QString GetDesktopFileByPid(int pid);

    void setDeviceMode(sched_policy::DeviceMode deviceMode);

Q_SIGNALS:
    void AppLaunched(const QString &appId);

private:
    void initAppLauncher();
    void sendAppLauncherErrorReply();

private:
    std::unique_ptr<AppLauncher> m_appLauncher;
    ProcessInfoManager &m_processInfoManager;
    AppChooser m_appChooser;
};

#endif // APPLAUNCHMANAGER_H
