#ifndef CPUENERGYMETER_H
#define CPUENERGYMETER_H

#include <chrono>
#include "energymeter.h"
#include "base/daemondbusinterface.h"

class CpuEnergyMeter : public EnergyMeter
{
public:
    CpuEnergyMeter();
    ~CpuEnergyMeter() = default;

    void startMeasurement() override;
    void endMeasurement() override;
    double energyConsumption() const override;
    double energyConsumptionRate() const override;

private:
    DaemonDbusInterface m_dbusInterface;
    //
    double m_startEnergy;
    double m_endEnergy;
    std::chrono::high_resolution_clock::time_point m_startTimePoint;
    std::chrono::high_resolution_clock::time_point m_endTimePoint;
};

#endif // CPUENERGYMETER_H
