#ifndef GROUPMANAGER_H
#define GROUPMANAGER_H

#include <jsoncpp/json/json.h>
#include "groupmanagementunit.h"

class GroupManager
{
public:
    GroupManager() = default;

    void excutePolicy(const std::string &policyId);
    void setGroupConfigs(const Json::Value &configs);

    void createProcessGroup(
        const std::string &cgroupName, const std::vector<int> &pids,
        sched_policy::GroupType parentGroupType);

    void moveProcessToGroup(
        int parentPid, std::vector<int> &childPids,
        sched_policy::GroupType parentGroupType);

    std::string groupPath(sched_policy::GroupType type);

    void reclaimProcessGroups(const std::vector<std::string> &groupNames);

private:
    void initGroups();

private:
    std::unique_ptr<GroupManagementUnitCreator> m_unitCreator;
    std::map<sched_policy::GroupType, std::unique_ptr<GroupManagementUnit>> m_groupUnits;
    ResourceManagerInterface m_resourceManagerInterface;
    Json::Value m_groupConfigs;
};

#endif // GROUPMANAGER_H
