#include "processinfomanager.h"

ProcessInfoManager::ProcessInfoManager(const std::shared_ptr<ConfigManager> &configManager)
    : m_appInfoManager(configManager)
{

}

void ProcessInfoManager::handleWindowAdded(uint wid)
{
    m_appInfoManager.handleWindowAdded(wid);
}

void ProcessInfoManager::handleWindowRemoved(uint wid)
{
    m_appInfoManager.handleWindowRemoved(wid);
}

void ProcessInfoManager::handleActiveWindowChanged(uint wid)
{
    m_appInfoManager.handleActiveWindowChanged(wid);
}

void ProcessInfoManager::handleWindowMinimized(uint wid)
{
    m_appInfoManager.handleWindowMinimized(wid);
}

void ProcessInfoManager::handleExceptionGroupSessionApp(const std::string &desktopFile, int pid)
{
    m_appInfoManager.handleExceptionGroupSessionApp(desktopFile, pid);
}

void ProcessInfoManager::handleMprisDbusAdded(int pid, const std::string &service)
{
    m_appInfoManager.handleMprisDbusAdded(pid, service);
}

void ProcessInfoManager::createAppInstance(const std::string &desktopFile, int pid)
{
    m_appInfoManager.createAppInstance(desktopFile, pid);
}

void ProcessInfoManager::setAppGroupName(const std::string &appId, const std::string &groupName)
{
    m_appInfoManager.setAppGroupName(appId, groupName);
}

void ProcessInfoManager::forceChangCachedStateTo(sched_policy::AppState state)
{
    m_appInfoManager.forceChangCachedStateTo(state);
}

bool ProcessInfoManager::forceChangeAppStateByPid(int pid, sched_policy::AppState state)
{
    return m_appInfoManager.forceChangeAppStateByPid(pid, state);
}

void ProcessInfoManager::setBackgroundToCachedStateInterval(int interval)
{
    m_appInfoManager.setBackgroundToCachedStateInterval(interval);
}

sched_policy::AppType ProcessInfoManager::getAppTypeByPid(int pid)
{
    return m_appInfoManager.getAppTypeByPid(pid);
}

std::string ProcessInfoManager::syncGetDesktopFileByPid(int pid)
{
    return m_appInfoManager.syncGetDesktopFileByPid(pid);
}

std::vector<AppInfo> ProcessInfoManager::getAllAppInfos()
{
    return m_appInfoManager.getAllAppInfos();
}

std::vector<AppInfo> ProcessInfoManager::getAppInfosWithState(sched_policy::AppState appState)
{
    return m_appInfoManager.getAppInfosWithState(appState);
}

AppInfo ProcessInfoManager::getLatestAppInfoByDesktopFile(
    const std::string &desktopFile, const std::vector<std::string> &args)
{
    return m_appInfoManager.getLatestAppInfoByDesktopFile(desktopFile, args);
}

AppInfo ProcessInfoManager::getLatestAppInfoByCmdline(const std::string &cmdline)
{
    return m_appInfoManager.getLatestAppInfoByCmdline(cmdline);
}

AppInfo ProcessInfoManager::getAppInfo(const std::string &appId)
{
    return m_appInfoManager.getAppInfo(appId);
}

std::string ProcessInfoManager::getDesktopFileByPid(int pid)
{
    return m_appInfoManager.getDesktopFileByPid(pid);
}

void ProcessInfoManager::setAppStartedCallback(AppChangedCallback callback)
{
    m_appInfoManager.setAppStartedCallback(std::move(callback));
}

void ProcessInfoManager::setAppStateChangedCallback(AppChangedCallback callback)
{
    m_appInfoManager.setAppStateChangedCallback(std::move(callback));
}

void ProcessInfoManager::setAppChildPidsUpdatedCallback(AppChangedCallback callback)
{
    m_appInfoManager.setAppChildPidsUpdatedCallback(std::move(callback));
}
