#ifndef RESOURCEMANAGERINTERFACE_H
#define RESOURCEMANAGERINTERFACE_H

#include "daemondbusinterface.h"
#include "systemddbusinterface.h"

class ResourceManagerInterface
{
public:
    void createPersistentProcessGroup(
        const std::string &path, const std::vector<std::string> &cgroupControllers);

    void createTransientProcessGroup(
        const std::string &path, const std::vector<int> &pids,
        const std::vector<std::string> &cgroupControllers);

    void setProcessGroupResourceLimit(
        const std::string &path, const std::string &controller,
        const std::string &file, const std::string &value);

    void moveProcessToGroup(
        const std::string &path, const std::vector<std::string> &controllers,
        const std::vector<int> &pids);

    void setCurrentUserServiceUnitPropertyEnabled(
        const std::string &property, bool enabled);

    void reclaimProcessGroups(const std::vector<std::string> &groupNames);

private:
    std::string getGroupNameFromPath(const std::string &path) const;
    std::string getGroupParentSliceFromPath(const std::string &path) const;

private:
    DaemonDbusInterface m_daemonDbus;
    SystemdDbusInterface m_systemdDbus;
};

#endif // RESOURCEMANAGERINTERFACE_H
