#include "resourcewarninghandler.h"

#include <QString>
#include <QDebug>

ResourceWarningHandler::ResourceWarningHandler(std::shared_ptr<ConfigManager> configManager,
                                               std::shared_ptr<SystemNotifiesSender> notifySender)
    : m_configManager(configManager)
    , m_notifySender(notifySender)
{
}

void ResourceWarningHandler::handleResourceWarning(const std::string &resource, int level)
{
    Q_UNUSED(level);
    Q_UNUSED(resource);

    if (!m_configManager->reousrceLimitEnabled()) {
        m_notifySender->sendResourceWarningNotify();
    } else if ("Memory" == resource && m_memoryWarningCallback){
        m_memoryWarningCallback(level);
    }
}

void ResourceWarningHandler::setMemoryWarningHanlder(MemoryWarningCallback callback)
{
    m_memoryWarningCallback = std::move(callback);
}
