#ifndef RESOURCEWARNINGHANDLER_H
#define RESOURCEWARNINGHANDLER_H

#include <string>
#include <memory>

#include <QTimer>

#include "systemnotifiessender.h"

class ConfigManager;
class ResourceWarningHandler
{
public:
    using MemoryWarningCallback = std::function<void(int)>;

    explicit ResourceWarningHandler(std::shared_ptr<ConfigManager> configManager,
                                    std::shared_ptr<SystemNotifiesSender> notifySender);

    void handleResourceWarning(const std::string &resource, int level);
    void setMemoryWarningHanlder(MemoryWarningCallback callback);

private:
    MemoryWarningCallback m_memoryWarningCallback;
    std::shared_ptr<ConfigManager> m_configManager;
    std::shared_ptr<SystemNotifiesSender> m_notifySender;
};

#endif // RESOURCEWARNINGHANDLER_H
