#ifndef SYSTEMNOTIFIESSENDER_H
#define SYSTEMNOTIFIESSENDER_H

#include <memory>

#include <QTimer>

#include "notifydbusinterface.h"
#include "configmanager.h"

class SystemNotifiesSender
{
public:
    SystemNotifiesSender(std::shared_ptr<ConfigManager> configManager);

    void sendResourceWarningNotify();

private:
    void initConnections();
    void handleResourceWarningNotifyClose(uint notifyId, uint reason);
    void handleResourceWarningActionInvoked(uint notifyId, const std::string &actionKey);

    std::shared_ptr<ConfigManager> m_configManager;
    std::unique_ptr<NotifyDBusInterface> m_notifyDBusInterface;
    std::unique_ptr<QTimer> m_notifyTimer;
    int m_resourceWarningNotifyId;
};

#endif // SYSTEMNOTIFIESSENDER_H
