#ifndef CPURAPLENERGYMETER_H
#define CPURAPLENERGYMETER_H

#include <string>

class CpuRaplEnergyMeter
{
public:
    CpuRaplEnergyMeter();

    double energyConsumption() const;
    bool isAvailable() const;

private:
    bool checkIfPowercapSupported() const;
    bool checkIfMsrSupported() const;
    std::string getMsrInterface() const;

    double readEnergyFromPowercap() const;
    double readEnergyFromMsr() const;
    double readRaplPowerUnit() const;
    int readPowercap(const std::string &interface, double *value) const;
    int readMsr(const std::string &interface, int offset, uint64_t *value) const;

private:
    bool m_isPowercapSupported;
    bool m_isMsrSupported;
};

#endif // CPURAPLENERGYMETER_H
