#ifndef LOGGER_H
#define LOGGER_H

#include <spdlog/logger.h>
#include <spdlog/sinks/daily_file_sink.h>

#include <QObject>

namespace common {

class Logger : public QObject
{
    Q_OBJECT
public:
    explicit Logger(QObject *parent = nullptr);
    static void outputMessage(QtMsgType type,
                              const QMessageLogContext &context,
                              const QString &msg);

private:
    static std::shared_ptr<spdlog::logger> logger();
};

};  // namespace common

#endif  // LOGGER_H
