#ifndef MEMORYWATCHER_H
#define MEMORYWATCHER_H

#include "resourcewatcher.h"
#include "resource.h"

class QTimer;
class MemoryWatcher : public ResourceWatcher
{
    Q_OBJECT
public:
    explicit MemoryWatcher(const std::map<resource::Resource, resource::ResourceUrgencyThreshold>& resourceThresholds,
                           QObject *parent = nullptr);

public Q_SLOTS:
    void start() override;
    void stop() override;

private Q_SLOTS:
    void checkMemoryRemaining();

private:
    void initMemoryThreshold(const std::map<resource::Resource, resource::ResourceUrgencyThreshold>& resourceThresholds);
    QTimer* m_timer;
    resource::ResourceUrgencyThreshold m_memoryThreshold;
};

#endif // MEMORYWATCHER_H
