#ifndef RESOURCE_H
#define RESOURCE_H

#include <map>
#include <string>

namespace resource {

enum class Resource {
    Unknown = -1,
    CPU,
    IO,
    Memory,
};

enum class ResourceUrgency {
    Unknown = -1,
    Low = 1,
    Medium = 2,
    High = 3,
};

//! \keyword ResourceUrgency, \value threshold
typedef std::map<ResourceUrgency, int> ResourceUrgencyThreshold;

std::string resourceEnumToString(Resource resource);
Resource stringToResourceEnum(const std::string& str);

int resourceUrgencyEnumToInt(ResourceUrgency urgency);
ResourceUrgency intToResourceUrgencyEnum(int urgency);
bool operator<(ResourceUrgency lhs, ResourceUrgency rhs);

} // namespace resource

#endif // RESOURCE_H
