#ifndef SYSTEMRESOURCEMANAGER_H
#define SYSTEMRESOURCEMANAGER_H

#include <QObject>

#include "resource.h"

class ResourceWatcher;
class SystemResourceManager : public QObject
{
    Q_OBJECT
public:
    explicit SystemResourceManager(QObject *parent = nullptr);
    void startWatchers();
    QString reclaimProcesses(const QList<int> &pids) const;

Q_SIGNALS:
    void ResourceThresholdWarning(QString resource, int level);

private:
    void startWatcherThread(ResourceWatcher* watcher, QThread* thread) const;
    std::vector<ResourceWatcher*> createWatchers(
        const std::map<resource::Resource, resource::ResourceUrgencyThreshold>& resourceThresholds) const;
    std::map<resource::Resource, resource::ResourceUrgencyThreshold> parserResourceThreshold() const;
    std::string reclaimProcess(int pid) const;

};

#endif // SYSTEMRESOURCEMANAGER_H
