#ifndef APPINFOHELPER_H
#define APPINFOHELPER_H

#include <sys/types.h>
#include <vector>
#include <string>

namespace appinfo_helper {
    std::string generateDesktopFileId(const std::string &desktopFile);
    bool isFromSameProcess(uint wid1, uint wid2);
    bool areAllTheWindowMinimize(const std::vector<uint> &wids);
    bool hasActiveWindow(const std::vector<uint> &wids);
    int getPidByWid(uint wid);
    bool isSameDesktopFile(const std::string &desktopFile1, const std::string &desktopFile2);
    bool hasSameDesktopName(const std::string &desktopFile1, const std::string &desktopFile2);
    bool hasSameMD5Hash(const std::string &desktopFile1, const std::string &desktopFile2);
    bool isKmreApp(const std::string &desktopFile);
    std::string getCmdlineFromDesktopFile(
        const std::string &desktopFile, const std::vector<std::string> &args);
    std::string findDesktopFileFromCmdline(const std::string &cmdline);
    // name.desktop
    std::string getDesktopFileName(const std::string &desktopFile);
    bool isTopApp(const std::string &desktopFile, const std::vector<std::string> &defaultTopApps);
    bool isSessionApp(const std::string &desktopFile, const std::vector<std::string> &availableFiles);
}

#endif // APPINFOHELPER_H
