#ifndef MISC_H
#define MISC_H

#include <string>
#include <vector>
#include <QList>

namespace misc {

namespace string {

bool startWith(const std::string &str, const std::string &prefix);
std::vector<std::string> split(const std::string &str, const char sep);

}

namespace stl2qt {

template<typename T>
QList<T> vector2QList(const std::vector<T> &vec) {
    QList<T> qlist;
    for (const auto &value : vec) {
        qlist.append(value);
    }
    return qlist;
}

QStringList vectorString2QStringList(const std::vector<std::string> &vec);
QList<uint> intVector2QtUintList(const std::vector<int> &vecs);

}

namespace qt2stl {

std::vector<std::string> qstringList2StdVectorString(const QStringList &qstrList);

}

namespace file {

std::string getFileNameFromPath(const std::string &filePath);
QByteArray fileMD5Hash(const std::string &filePath);
bool fileExists(const std::string &filePath);

}

namespace version {

int cgroupVersion();

}

}

#endif // MISC_H
